# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables


class ProjectFeatures(pulumi.CustomResource):
    features: pulumi.Output[dict]
    """
    Defines the status (`enabled`, `disabled`) of the project features.  
    Valid features `boards`, `repositories`, `pipelines`, `testplans`, `artifacts`
    """
    project_id: pulumi.Output[str]
    def __init__(__self__, resource_name, opts=None, features=None, project_id=None, __props__=None, __name__=None, __opts__=None):
        """
        Manages features for Azure DevOps projects

        ## Example Usage

        ```python
        import pulumi
        import pulumi_azuredevops as azuredevops

        tf_project_test_001 = azuredevops.Core.get_project(project_name="Test Project")
        my_project_features = azuredevops.core.ProjectFeatures("my-project-features",
            project_id=tf_project_test_001.id,
            features={
                "testplans": "disabled",
                "artifacts": "enabled",
            })
        ```
        ## Relevant Links

        No official documentation available

        ## PAT Permissions Required

        - **Project & Team**: Read, Write, & Manage

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[dict] features: Defines the status (`enabled`, `disabled`) of the project features.  
               Valid features `boards`, `repositories`, `pipelines`, `testplans`, `artifacts`
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if features is None:
                raise TypeError("Missing required property 'features'")
            __props__['features'] = features
            if project_id is None:
                raise TypeError("Missing required property 'project_id'")
            __props__['project_id'] = project_id
        super(ProjectFeatures, __self__).__init__(
            'azuredevops:Core/projectFeatures:ProjectFeatures',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, features=None, project_id=None):
        """
        Get an existing ProjectFeatures resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[dict] features: Defines the status (`enabled`, `disabled`) of the project features.  
               Valid features `boards`, `repositories`, `pipelines`, `testplans`, `artifacts`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["features"] = features
        __props__["project_id"] = project_id
        return ProjectFeatures(resource_name, opts=opts, __props__=__props__)

    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop
